function [u, iter] = cg_solver(A, b, eps_tol)
    u = zeros(size(b));
    r = b - A*u;
    p = zeros(size(b));
    s = 1;
    iter = 0;
    while sqrt(r'*r) > eps_tol
        t = r' * r;
        p = r + t/s*p;
        q = A*p;
        a = t / (p'*q);
        u = u + a*p;
        r = r - a*q;
        s = t;
        iter = iter+1;
    end
end